<?php
  /**************************************************************************\
  * phpGroupWare - Calendar                                                  *
  * http://www.phpgroupware.org                                              *
  * Based on Webcalendar by Craig Knudsen <cknudsen@radix.net>               *
  *          http://www.radix.net/~cknudsen                                  *
  * Modified by Mark Peters <skeeter@phpgroupware.org>                       *
  * --------------------------------------------                             *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/

	/* $Id: class.uialarm.inc.php,v 1.4 2001/12/28 15:53:33 skeeter Exp $ */

	class uialarm
	{
		var $template;
		var $template_dir;

		var $bo;
		var $event;

		var $debug = False;
//		var $debug = True;

		var $tz_offset;
		var $theme;

		var $public_functions = array(
			'manager' => True
		);

		function uialarm()
		{
			$GLOBALS['phpgw']->nextmatchs = CreateObject('phpgwapi.nextmatchs');
			$GLOBALS['phpgw']->browser    = CreateObject('phpgwapi.browser');
			
			$this->theme = $GLOBALS['phpgw_info']['theme'];

			$this->bo = CreateObject('calendar.boalarm');
			$this->tz_offset = $this->bo->tz_offset;

			if($this->debug)
			{
				echo "BO Owner : ".$this->bo->owner."<br>\n";
			}

			$this->template_dir = $GLOBALS['phpgw']->common->get_tpl_dir('calendar');
		}

		function prep_page()
		{
			$this->event = $this->bo->read_entry($this->bo->cal_id);

			$can_edit = $this->bo->can_user_edit($this->event);
				
			if(!$can_edit)
			{
				Header('Location : '.$GLOBALS['phpgw']->link('/index.php',
						Array(
							'menuaction'	=> 'calendar.uicalendar.view',
							'cal_id'		=> $this->bo->cal_id
						)
					)
				);
			}

  			unset($GLOBALS['phpgw_info']['flags']['noheader']);
   		unset($GLOBALS['phpgw_info']['flags']['nonavbar']);
	   	$GLOBALS['phpgw']->common->phpgw_header();

			$this->template = CreateObject('phpgwapi.Template',$this->template_dir);

			$this->template->set_unknowns('keep');
			$this->template->set_file(
				Array(
  					'alarm'	=> 'alarm.tpl'
   				)
			);
			$this->template->set_block('alarm','alarm_management','alarm_management');
			$this->template->set_block('alarm','alarm_headers','alarm_headers');
			$this->template->set_block('alarm','list','list');
			$this->template->set_block('alarm','hr','hr');
		}

		function output_template_array($row,$list,$var)
		{
			$this->template->set_var($var);
			$this->template->parse($row,$list,True);
		}

		/* Public functions */

		function manager()
		{
			$this->prep_page();
			
			// Modified By Kazuya Nouchi 2003/2/24
			$today = date('Ymd',time());
			$image_dir = PHPGW_IMAGES;
			$day_tab = lang('daily');$week_tab = lang('weekly');$month_tab = lang('monthly');$year_tab = lang('yearly');
			$matrixview_tab = lang('daily matrix view');$lang_today_schedule = lang('schedule of today');
			$calendar = CreateObject('calendar.uicalendar');
			$day_url = $calendar->page('day','&date='.$today);
			$week_url = $calendar->page('week','&date='.$today);
			$month_url = $calendar->page('month','&date='.$today);
			$year_url = $calendar->page('year','&date='.$today);
			$matrix_url = $calendar->page('matrixselect','&date='.$today);
			$title = lang('calendar');
			$alarm_disp = lang('alarm set display description');
			$lang_user_setting = lang('user setting');
			$addressbook_pref_url = $GLOBALS['phpgw']->link('/index.php','menuaction=preferences.uiaclprefs.index&acl_app=calendar');
$buff = <<< EOF
<table width='100%' height='39' border='0' cellspacing='0' cellpadding='0'>
  <tr align='left' valign='bottom'>
	<td width='100%' height='39' background='$image_dir/bg_line01.gif'>
	  <table height='39' border='0' cellspacing='0' cellpadding='0'>
		<tr background='$image_dir/spacer30.gif'>
		  <td width='119' rowspan='2' valign='middle' background='$image_dir/calendar_title_img.gif' nowrap><img SRC='$image_dir/spacer10.gif' WIDTH='8' HEIGHT='1'><span class='nomal14'><b>$title</b></span></td>
		  <td width='10' height='12'></td>
		  <td></td>
		  <td width='23'></td>
		  <td></td>
		  <td width='23'></td>
		  <td></td>
		  <td width='23'></td>
		  <td></td>
		  <td width='23'></td>
		  <td></td>
		  <td width='21'></td>
		  <td width='25'></td>
		  <td></td>
		</tr>
		<tr align='center' valign='middle' background='$image_dir/spacer30.gif'>
		  <td width='10' height='27' align='right' valign='bottom'><img SRC='$image_dir/tag_l02.gif' WIDTH='10' HEIGHT='27'></td>
		  <td background='$image_dir/tag_bg_02.gif' nowrap><a HREF='$day_url'><span class='tag' id='tFFFFFF'>$day_tab</span></a></td>
		  <td width='23' align='right' valign='bottom'><img SRC='$image_dir/tag_btw02.gif' WIDTH='23' HEIGHT='27'></td>
		  <td background='$image_dir/tag_bg_02.gif' nowrap><a HREF='$week_url'><span class='tag' id='tFFFFFF'>$week_tab</span></a></td>
		  <td width='23' align='right' valign='bottom'><img SRC='$image_dir/tag_btw02.gif' WIDTH='23' HEIGHT='27'></td>
		  <td background='$image_dir/tag_bg_02.gif' nowrap><a HREF='$month_url'><span class='tag' id='tFFFFFF'>$month_tab</span></a></td>
		  <td width='23' align='right' valign='bottom'><img SRC='$image_dir/tag_btw02.gif' WIDTH='23' HEIGHT='27'></td>
		  <td background='$image_dir/tag_bg_02.gif' nowrap><a HREF='$year_url'><span class='tag' id='tFFFFFF'>$year_tab</span></a></td>
		  <td width='23' align='right' valign='bottom'><img SRC='$image_dir/tag_btw02.gif' WIDTH='23' HEIGHT='27'></td>
		  <td background='$image_dir/tag_bg_02.gif' nowrap><a HREF='$matrix_url'><span class='tag' id='tFFFFFF'>$matrixview_tab</span></a></td>
		  <td width='23' align='right' valign='bottom'><img SRC='$image_dir/tag_btw02.gif' WIDTH='23' HEIGHT='27'></td>
		  <td background='$image_dir/tag_bg_02.gif' nowrap><a HREF='$addressbook_pref_url'><span class='tag' id='tFFFFFF'>$lang_user_setting</span></a></td>
		  <td width='21' align='right' valign='bottom'><img SRC='$image_dir/tag_r.gif' WIDTH='21' HEIGHT='27'></td>
		  <td width='25' align='right' nowrap><a HREF='$day_url'><img SRC='$image_dir/clnd_icn_s.gif' WIDTH='12' HEIGHT='16' border='0' alt='' title='$lang_today_schedule'></a><img SRC='$image_dir/spacer10.gif' WIDTH='3' HEIGHT='1'></td>
		  <td nowrap><a HREF='$day_url'><span class='nomal10' id='t000000''>$lang_today_schedule</span></a></td>
		</tr>
	  </table>
	</td>
  </tr>
</table>
<table width="100%" height="31" border="0" cellspacing="0" cellpadding="0">
  <tr>
    <td height="30" align="left" valign="middle" bgcolor="#669966" nowrap>
	  <table border="0" cellspacing="0" cellpadding="0">
		<tr valign="middle">
		  <td width="25" align="center"><img SRC="$image_dir/clnd_icn_s.gif" WIDTH="12" HEIGHT="16" alt="$title"></td>
		  <td align="left" nowrap class="nomal12" id="tFFFFFF">$alarm_disp</td>
		</tr>
	  </table>
	</td>
  </tr>
  <tr>
	<td height="1" bgcolor="#336633"><img SRC="$image_dir/spacer10.gif" WIDTH="1" HEIGHT="1"></td>
  </tr>
</table>
EOF;
			print $buff;

			echo ExecMethod('calendar.uicalendar.view_event',$this->event);
			// Removed By Kazuya Nouchi POPCOM INC 2002/5/30
//			$this->template->set_var('hr_text','<center><b>'.lang('Alarms').'</b></center></br><hr>');
//			$this->template->parse('row','hr',True);
			//-------------------------------------------------
			$var = Array(
				'action_url'	=> $GLOBALS['phpgw']->link('/index.php',Array('menuaction'=>'calendar.uialarm.form_handler')),
				'time_lang'		=> lang('Time'),
				'text_lang'		=> lang('Text'),
				'enabled_pict'		=> $GLOBALS['phpgw']->common->image('calendar','enabled.gif'),
				'disabled_pict'	=> $GLOBALS['phpgw']->common->image('calendar','disabled.gif')
			);
			
			$this->output_template_array('row','alarm_headers',$var);
			$this->template->set_var('hr_text','<hr>');
			$this->template->parse('row','hr',True);

			if($this->event['alarm'])
			{
				@reset($this->event['alarm']);
				while(list($key,$alarm) = each($this->event['alarm']))
				{
					$var = Array(
						'edit_box'	=> '<input type="checkbox" name="alarm[id]" value="'.$alarm['id'].'">',
						'field'	=> $icon.$GLOBALS['phpgw']->common->show_date($alarm['time']),
						'data'	=> $alarm['text'],
						'alarm_enabled'	=> ($alarm['enabled']?'<img src="'.$GLOBALS['phpgw']->common->image('calendar','enabled.gif').'" width="13" height="13" alt="enabled">':'&nbsp;'),
						'alarm_disabled'	=> (!$alarm['enabled']?'<img src="'.$GLOBALS['phpgw']->common->image('calendar','disabled.gif').'" width="13" height="13" alt="disabled">':'&nbsp;')
					);
					$this->output_template_array('row','list',$var);
				}
			}
			$this->template->set_var('hr_text','<hr>');
			$this->template->parse('row','hr',True);

			echo $this->template->fp('out','alarm_management');
		}

		function add_alarm()
		{
			$this->prep_page();
		}
	}
