<?php
	/*****************************************************************************\
	* phpGroupWare - uiForums                                                     *
	* http://www.phpgroupware.org                                                 *
	* Written by Mark A Peters <skeeter@phpgroupware.org>                         *
	* Based off of Jani Hirvinen <jpkh@shadownet.com>                             *
	* -------------------------------------------                                 *
	*  This program is free software; you	can redistribute it and/or modify it   *
	*  under the terms of	the GNU	General	Public License as published by the  *
	*  Free Software Foundation; either version 2	of the License,	or (at your *
	*  option) any later version.                                                 *
	\*****************************************************************************/

	/* $Id: class.uiforum.inc.php,v 1.1.2.5 2002/02/15 03:54:59 skeeter Exp $ */

	class uiforum
	{

		var $public_functions = array(
			'index' => True,
			'forum' => True,
			'threads'	=> True,
			'read'	=> True,
			'post'	=> True,
			// Added By Kazuya Nouchi POPCOM INC 2003/1/29
			'search'	=> True
			//-----------------------		
		);

		var $debug;
		var $bo;
		var $template_dir;
		var $template;

		function uiforum($session=0)
		{
			$GLOBALS['phpgw']->nextmatchs = CreateObject('phpgwapi.nextmatchs');
			$this->bo = CreateObject('forum.boforum',1);
			$this->debug = $this->bo->debug;
			if($this->bo->use_session)
			{
				$this->save_sessiondata();
			}

			if($this->debug)
			{
				$this->_debug_sqsof();
			}
			$this->template_dir = $GLOBALS['phpgw']->common->get_tpl_dir('forum');
			$this->template = CreateObject('phpgwapi.Template',$this->template_dir);
		}

		/* Private functions */
		function _debug_sqsof()
		{
			$data = array(
				'view'=> $this->bo->view,
				'location'	=> $this->bo->location,
				'cat_id'=> $this->bo->cat_id,
				'forum_id'	=> $this->bo->forum_id
			);
			echo '<br>UI:';
			_debug_array($data);
		}

		/* Called only by get_list(), just prior to page footer. */
		function save_sessiondata()
		{
			$data = array(
				'view'=> $this->bo->view,
				'location'	=> $this->bo->location,
				'cat_id'=> $this->bo->cat_id,
				'forum_id'	=> $this->bo->forum_id
			);
			$this->bo->save_sessiondata($data);
		}

		function index()
		{
			unset($GLOBALS['phpgw_info']['flags']['noheader']);
			unset($GLOBALS['phpgw_info']['flags']['nonavbar']);
			unset($GLOBALS['phpgw_info']['flags']['noappheader']);
			unset($GLOBALS['phpgw_info']['flags']['noappfooter']);
			$GLOBALS['phpgw']->common->phpgw_header();

			$this->template->set_file(
				Array(
					'INDEX'	=> 'index.body.tpl'
				)
			);
			$this->template->set_block('INDEX','CategoryForum','CatF');

			$var = Array(
				'CAT_IMG'	=> $GLOBALS['phpgw']->common->image('forum','category'),
				'BGROUND'	=> $GLOBALS['phpgw_info']['theme']['th_bg'],
				'FORUM'	=> lang('Forum')
			);
			$this->template->set_var($var);

			$cats = $this->bo->get_all_cat_info();

			// Modified By Kazuya Nouchi POPCOM INC 2002/6/6
			if ($GLOBALS['phpgw_info']['server']['template_set'])
//			if ($GLOBALS['phpgw_info']['server']['template_set'] == 'savant')
			{
				while(is_array($cats) && list($key,$cat) = each($cats))
				{
					$var = Array(
						'CAT_ID'			=> $cat['id'],
						'CAT_NAME'			=> $cat['name'],
						'CAT_SELECTED'		=> ($this->bo->cat_id == $cat['id'] ? 'selected' : ''),
						'forum_post_url'	=> $GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiforum.index'),
						// Added By Kazuya Nouchi POPCOM INC 2003/12/29
						'search_action_url'	=> $GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiforum.search')
						//--------------------------------------------------------------------------------------------
					);
					$this->template->set_var($var);
					$this->template->parse('CatF','CategoryForum',true);
					if ($this->bo->cat_id == $cat['id'])
					{
						$value_total = $cat['total'];
						$value_desc = $cat['descr'];
						$value_last_post = $cat['last_post'];
					}				
				}
				if (!$cats)
				{
					$var = Array(
						'CAT_NAME'			=> lang('no category')
					);
					$this->template->set_var($var);
					$this->template->parse('CatF','CategoryForum',true);				
				}
				$forum_info = $this->bo->get_forums_for_cat(isset($this->bo->cat_id) ? $this->bo->cat_id : 1);
				
				$this->template->set_block('INDEX','forum_list','rows');
				if($forum_info)
				{
					unset($value_total);
					unset($value_desc);
					unset($value_last_post);
					while (list($key,$forum) = each($forum_info))
					{
						$this->template->set_var(
							Array(
								'FORUM_NAME'		=> $forum['name'],
								'FORUM_ID'			=> $forum['id'],
								'FORUM_SELECTED'	=> ($this->bo->forum_id == $forum['id'] ? 'selected' : ''),
								'thread_post_url'	=> $GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiforum.index')
							)
						);
						if ($this->bo->forum_id == $forum['id'])
						{
							$value_total = $forum['total'];
							$value_desc = $forum['descr'];
							$value_last_post = $forum['last_post'];
						}
						else if (!isset($this->bo->forum_id))
						{
							if (!isset($value_total)) $value_total = $forum['total'];
							if (!isset($value_desc)) $value_desc = $forum['descr'];
							if (!isset($value_last_post)) $value_last_post = $forum['last_post'];
						}
						$this->template->parse('rows','forum_list',true);
					}
				}
				else
				{
					$var = Array(
						'FORUM_NAME'	=> lang('no forum')
					);
					$this->template->set_var($var);
					$this->template->parse('rows','forum_list',true);
				}
				$is_collapsed = (strcmp($this->bo->view,'collapsed') == 0);
				$thread_listing = $this->bo->get_thread($this->bo->cat_id ? $this->bo->cat_id : 1,
					$this->bo->forum_id ? $this->bo->forum_id : 1,$is_collapsed);
				$this->template->set_block('INDEX','CollapseThreads','CollapseT');
				$this->template->set_block('INDEX','NormalThreads','NormalT');
				$this->template->set_block('INDEX','ErrorMessage','ErrMsgT');
				if($is_collapsed)
				{
					$this->template->set_var('THREAD_IMG',$GLOBALS['phpgw']->common->image('forum','thread'));
					if (is_array($thread_listing))
						reset($thread_listing);
					while($thread_listing && list($key,$thread) = each($thread_listing))
					{					
						$var = Array(
							'TOPIC'	=> ($thread['subject']?$thread['subject']:'[No subject]'),
							'AUTHOR'	=> ($thread['author']?$GLOBALS['phpgw']->common->grab_owner_name($thread['author']):lang('Unknown')),
							'REPLIES'	=> $thread['replies'],
							'READ_LINK'	=> $GLOBALS['phpgw']->link('/index.php',
									Array(
										'menuaction'	=> 'forum.uiforum.read',
										'msg'	=> $thread['id']
									)
								),
							'LATESTREPLY'	=> $thread['last_reply'],
							'TOPIC_ID'		=> sprintf('%04d', $thread['main'])
						);
						$this->template->set_var($var);
						$this->template->parse('CollapseT','CollapseThreads',true);
					}
					$this->template->set_var('view_collapsed_selected','selected');
				}
				else
				{
					$line_img1 = $GLOBALS['phpgw']->common->image('forum','line01.gif');
					$line_img2 = $GLOBALS['phpgw']->common->image('forum','line02.gif');
					$line_img3 = $GLOBALS['phpgw']->common->image('forum','line03.gif');
					if (is_array($thread_listing))
						reset($thread_listing);
					while($thread_listing && list($key,$thread) = each($thread_listing))
					{
						$move = '';
						$row_span = '';
						for($tmp = 1;$tmp <= $thread['depth']; $tmp++)
						{

							$move .= "<td height='20' width='20'></td>\n";
						}
						if (is_array($thread_listing[$key+1]))
						{
							if ($thread_listing[$key+1]['depth'] == 0)
							{
								$row_span = '<td height="1" bgcolor="#CCCCCC"></td>';
							}						
						}				
						$var = Array(
							'TOPIC'	=> ($thread['subject']?$thread['subject']:'[No subject]'),
							'AUTHOR'	=> ($thread['author']?$GLOBALS['phpgw']->common->grab_owner_name($thread['author']):lang('Unknown')),
							'REPLIES'	=> $thread['replies'],
							'READ_LINK'	=> $GLOBALS['phpgw']->link('/index.php',
									Array(
										'menuaction'	=> 'forum.uiforum.read',
										'msg'	=> $thread['id'],
										'pos'	=> $thread['pos']
									)
								),
							'LATESTREPLY'		=> $thread['last_reply'],
							'DEPTH'				=> $move,
							'TOPIC_ID'			=> sprintf('%04d', $thread['main']),
							'icon_image_url'	=> $GLOBALS['phpgw']->common->image('forum',$thread['depth'] == 0 ? 'thread' : 'message'),
							'row_space'			=> ($thread['depth'] == 0 ? 2 : 0),
							'row_span'			=> $row_span
						);
						$this->template->set_var($var);
						$this->template->parse('NormalT','NormalThreads',true);
					} //end while
					$this->template->set_var('view_threads_selected','selected');
					
				}
				if (!$cats)
				{
					$var = Array(
						'errormsg'	=> lang('Category not found')
					);
					$this->template->set_var($var);
					$this->template->parse('ErrMsgT','ErrorMessage',true);
				}	
				if (!$forum_info)
				{
					$var = Array(
						'errormsg'	=> lang('Forum not found')
					);
					$this->template->set_var($var);
					$this->template->parse('ErrMsgT','ErrorMessage',true);
				}	
				if (!$thread_listing)
				{
					$var = Array(
						'errormsg'	=> lang('Topic not found')
					);
					$this->template->set_var($var);
					$this->template->parse('ErrMsgT','ErrorMessage',true);
				}
				// Added By Kazuya Nouchi POPCOM INC 2002/12/17
				if ($GLOBALS['phpgw_info']['user']['apps']['admin'])
				{
					$maintenance_tab = '<td width="21" align="right" valign="bottom">'.'<img SRC="'.PHPGW_IMAGES.'/tag_btw02.gif" WIDTH="21" HEIGHT="27"></td>'."\n";
					$maintenance_tab .= '<td background="'.PHPGW_IMAGES.'/tag_bg_02.gif" nowrap><a HREF="'.$GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiadmin.index').
						'"><span class="tag" id="tFFFFFF">'.lang('maintenance')."</span></a></td>\n";
					$maintenance_tab .= '<td width="21" align="right" valign="bottom"><img SRC="'.PHPGW_IMAGES.'/tag_r.gif" WIDTH="21" HEIGHT="27"></td>'."\n";
				}
				else
				{
					$maintenance_tab = '<td width="21" align="right" valign="bottom">'.'<img SRC="'.PHPGW_IMAGES.'/tag_r.gif" WIDTH="21" HEIGHT="27"></td>'."\n";
					$maintenance_tab .= "<td></td>\n<td></td>\n";
				}
				//---------------------------------------------------------
				$var = Array(
					'image_dir'			=> PHPGW_IMAGES,
					'value_total'		=> ($value_total ? $value_total : 0),
					'value_desc'		=> $value_desc,
					'value_last_post'	=> $value_last_post,
					'cat_id_value'		=> (isset($this->bo->cat_id) ? $this->bo->cat_id : 1),
					'forum_id_value'	=> (isset($this->bo->forum_id) ? $this->bo->forum_id : 1),
					'addnew_topic_url'	=> $GLOBALS['phpgw']->link('/index.php',Array(
										'menuaction'	=> 'forum.uiforum.post',
										'type'	=> 'new')),
					'admin_url'			=> $GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiadmin.index'),
					// Added By Kazuya Nouchi POPCOM INC 2002/12/17
					'maintenance_tab'	=> $maintenance_tab,
					//----------------------------------------------
				);
				$this->template->set_var($var);								
			}
			else
			{
				while(list($key,$cat) = each($cats))
				{
					$tr_color = $GLOBALS['phpgw']->nextmatchs->alternate_row_color($tr_color);
					$var = Array(
						'COLOR'	=> $tr_color,
						'CAT'	=> $cat['name'],
						'DESC'	=> $cat['descr'],
						'CAT_LINK'	=> $GLOBALS['phpgw']->link('/index.php',
								Array(
									'menuaction'	=> 'forum.uiforum.forum',
									'cat_id'	=> $cat['id']
								)
							),
						'value_last_post' => $cat['last_post'],
						'value_total'     => $cat['total']
					);
					$this->template->set_var($var);
					$this->template->parse('CatF','CategoryForum',true);
				}
			}
			//--------------------------------------------
			$this->template->parse('Out','INDEX');
			$this->template->p('Out');
		}

		function forum()
		{
			unset($GLOBALS['phpgw_info']['flags']['noheader']);
			unset($GLOBALS['phpgw_info']['flags']['nonavbar']);
			unset($GLOBALS['phpgw_info']['flags']['noappheader']);
			unset($GLOBALS['phpgw_info']['flags']['noappfooter']);
			$GLOBALS['phpgw']->common->phpgw_header();

			$this->template->set_file(
				Array(
					'_list'	=> 'forums.body.tpl'
				)
			);
			$this->template->set_block('_list','row_empty');
			$this->template->set_block('_list','list');
			$this->template->set_block('_list','row');

			$cat = $this->bo->get_cat_info($this->bo->cat_id);

			$var = Array(
				'BGROUND'	=> $GLOBALS['phpgw_info']['theme']['th_bg'],
				'FORUM_IMG' => $GLOBALS['phpgw']->common->image('forum','forum'),
				'CATEGORY'       => $cat['name'],
				'LANG_MAIN'      => lang('Forum'),
				'MAIN_LINK'      => $GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiforum.index')
			);
			$this->template->set_var($var);

			$forum_info = $this->bo->get_forums_for_cat($this->bo->cat_id);
			
			if(!$forum_info)
			{
				$GLOBALS['phpgw']->nextmatchs->template_alternate_row_color(&$this->template);
				$this->template->set_var('lang_no_forums',lang('There are no forums in this category'));
				$this->template->fp('rows','row_empty');
			}
			else
			{
				while (list($key,$forum) = each($forum_info))
				{
					$GLOBALS['phpgw']->nextmatchs->template_alternate_row_color(&$this->template);
					$this->template->set_var(
						Array(
							'NAME'              => $forum['name'],
							'DESC'              => $forum['descr'],
							'THREADS_LINK'      => $GLOBALS['phpgw']->link('/index.php',
									Array(
										'menuaction'	=> 'forum.uiforum.threads',
										'forum_id'	=> $forum['id']
									)
							 ),
							'value_last_post' => $forum['last_post'],
							'value_total'     => $forum['total']
						)
					);
					$this->template->fp('rows','row',True);
				}
			}
			$this->template->pfp('out','list');
		}

		function threads()
		{
			unset($GLOBALS['phpgw_info']['flags']['noheader']);
			unset($GLOBALS['phpgw_info']['flags']['nonavbar']);
			unset($GLOBALS['phpgw_info']['flags']['noappheader']);
			unset($GLOBALS['phpgw_info']['flags']['noappfooter']);
			$GLOBALS['phpgw']->common->phpgw_header();

			$category = $this->bo->get_cat_info($this->bo->cat_id);
			$forum = $this->bo->get_forum_info($this->bo->cat_id,$this->bo->forum_id);

			$pre_var	= array(
				'BGROUND'        => $GLOBALS['phpgw_info']['theme']['th_bg'],
				'LANG_TOPIC'     => lang('Topic'),
				'LANG_AUTHOR'    => lang('Author'),
				'LANG_REPLIES'   => lang('Replies'),
				'LANG_LATREP'    => lang('Latest Reply'),
				'LANG_MAIN'      => lang('Forums'),
				'LANG_NEWTOPIC'  => lang('New Topic'),
				'LANG_CATEGORY'  => $category['name'],
				'LANG_FORUM'     => $forum['name'],
				'FORUM_LINK'     => $GLOBALS['phpgw']->link('/index.php',
						Array(
							'menuaction'	=> 'forum.uiforum.forum',
							'cat_id'	=>	$this->bo->cat_id
						)
					),
				'MAIN_LINK'      => $GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiforum.index'),
				'POST_LINK'      => $GLOBALS['phpgw']->link('/index.php',
						Array(
							'menuaction' => 'forum.uiforum.post',
							'type'	=> 'new'
						)
					)
			);

			$is_collapsed = (strcmp($this->bo->view,'collapsed') == 0);
			$thread_listing = $this->bo->get_thread($this->bo->cat_id,$this->bo->forum_id,$is_collapsed);
			if($is_collapsed)
			{
				$this->template->set_file(
					Array(
						'COLLAPSE'	=> 'collapse.threads.tpl'
					)
				);
				$this->template->set_block('COLLAPSE','CollapseThreads','CollapseT');

				$this->template->set_var($pre_var);
				$this->template->set_var('THREAD_IMG',$GLOBALS['phpgw']->common->image('forum','thread'));

				while($thread_listing && list($key,$thread) = each($thread_listing))
				{
					$GLOBALS['tr_color'] = $GLOBALS['phpgw']->nextmatchs->alternate_row_color($GLOBALS['tr_color']);
					
					$var = Array(
						'COLOR'	=> $GLOBALS['tr_color'],
						'TOPIC'	=> ($thread['subject']?$thread['subject']:'[No subject]'),
						'AUTHOR'	=> ($thread['author']?$GLOBALS['phpgw']->common->grab_owner_name($thread['author']):lang('Unknown')),
						'REPLIES'	=> $thread['replies'],
						'READ_LINK'	=> $GLOBALS['phpgw']->link('/index.php',
								Array(
									'menuaction'	=> 'forum.uiforum.read',
									'msg'	=> $thread['id']
								)
							),
						'LATESTREPLY'	=> $thread['last_reply']
					);
					$this->template->set_var($var);
					$this->template->parse('CollapseT','CollapseThreads',true);
				}
				$var = Array(
					'THREADS_LINK'	=> $GLOBALS['phpgw']->link('/index.php',
							Array(
								'menuaction'	=> 'forum.uiforum.threads',
								'view'	=> 'threads'
							)
						),
					'LANG_THREADS' => lang('View Threads')
				);
				$this->template->set_var($var);
				$this->template->parse('Out','COLLAPSE');
			} //end if
			//For viewing the normal view
			else
			{
				$this->template->set_file(
					Array(
						'NORMAL'	=> 'normal.threads.tpl'
					)
				);
				$this->template->set_block('NORMAL','NormalThreads','NormalT');
				$this->template->set_var($pre_var);

				while($thread_listing && list($key,$thread) = each($thread_listing))
				{
					$GLOBALS['tr_color'] = $GLOBALS['phpgw']->nextmatchs->alternate_row_color($GLOBALS['tr_color']);

					$move = '';
					for($tmp = 1;$tmp <= $thread['depth']; $tmp++)
					{
						$move .= '&nbsp;&nbsp;';
					}
					$move .= '<img src="'.$GLOBALS['phpgw']->common->image('forum','n').'">';
					$move .= '&nbsp;&nbsp;';

					$var = Array(
						'COLOR'	=> $GLOBALS['tr_color'],
						'TOPIC'	=> ($thread['subject']?$thread['subject']:'[No subject]'),
						'AUTHOR'	=> ($thread['author']?$GLOBALS['phpgw']->common->grab_owner_name($thread['author']):lang('Unknown')),
						'REPLIES'	=> $thread['replies'],
						'READ_LINK'	=> $GLOBALS['phpgw']->link('/index.php',
								Array(
									'menuaction'	=> 'forum.uiforum.read',
									'msg'	=> $thread['id'],
									'pos'	=> $thread['pos']
								)
							),
						'LATESTREPLY'	=> $thread['last_reply'],
						'DEPTH'	=> $move
					);
					$this->template->set_var($var);
					$this->template->parse('NormalT','NormalThreads',true);
				} //end while

				$var = Array(
					'THREADS_LINK'	=> $GLOBALS['phpgw']->link('/index.php',
							Array(
								'menuaction'	=> 'forum.uiforum.threads',
								'view'	=> 'collapsed'
							)
						),
					'LANG_THREADS' => lang('Collapse Threads')
				);
				$this->template->set_var($var);
				$this->template->parse('Out','NORMAL');
			}
			$this->template->p('Out');
		}

		function read()
		{
			unset($GLOBALS['phpgw_info']['flags']['noheader']);
			unset($GLOBALS['phpgw_info']['flags']['nonavbar']);
			unset($GLOBALS['phpgw_info']['flags']['noappheader']);
			unset($GLOBALS['phpgw_info']['flags']['noappfooter']);
			$GLOBALS['phpgw']->common->phpgw_header();

			$this->template->set_file(
				Array(
					'READ'	=> 'read.body.tpl'
				)
			);

			$this->template->set_block('READ','read_body','read_body');
			$this->template->set_block('READ','msg_template','msg_template');

			$msg = $GLOBALS['HTTP_GET_VARS']['msg'];
			$pos = $GLOBALS['HTTP_GET_VARS']['pos'];

			$this->template->set_var('row_off',$GLOBALS['phpgw_info']['theme']['row_off']);
			$this->template->set_var('row_on',$GLOBALS['phpgw_info']['theme']['row_on']);

			$category = $this->bo->get_cat_info($this->bo->cat_id);
			$forum = $this->bo->get_forum_info($this->bo->cat_id,$this->bo->forum_id);
			// Added By Kazuya Nouchi POPCOM INC 2002/12/17
			if ($GLOBALS['phpgw_info']['user']['apps']['admin'])
			{
				$maintenance_tab = '<td width="21" align="right" valign="bottom">'.'<img SRC="'.PHPGW_IMAGES.'/tag_btw02.gif" WIDTH="21" HEIGHT="27"></td>'."\n";
				$maintenance_tab .= '<td background="'.PHPGW_IMAGES.'/tag_bg_02.gif" nowrap><a HREF="'.$GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiadmin.index').
					'"><span class="tag" id="tFFFFFF">'.lang('maintenance')."</span></a></td>\n";
				$maintenance_tab .= '<td width="21" align="right" valign="bottom"><img SRC="'.PHPGW_IMAGES.'/tag_r.gif" WIDTH="21" HEIGHT="27"></td>'."\n";
			}
			else
			{
				$maintenance_tab = '<td width="21" align="right" valign="bottom">'.'<img SRC="'.PHPGW_IMAGES.'/tag_r.gif" WIDTH="21" HEIGHT="27"></td>'."\n";
				$maintenance_tab .= "<td></td>\n<td></td>\n";
			}
			//----------------------------------------------------------------------------------------
			$var = array(
				// Added By Kazuya Nouchi POPCOM INC 2002/6/7
				'image_dir'		=> PHPGW_IMAGES,
				'admin_url'		=> $GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiadmin.index'),
				//----------------------------------------------
				'BGROUND'       => $GLOBALS['phpgw_info']['theme']['th_bg'],
				'LANG_TOPIC'    => lang('Topic'),
				'LANG_AUTHOR'   => lang('Author'),
				'LANG_REPLIES'  => lang('Replies'),
				'LANG_LATREP'   => lang('Latest Reply'),
				'LANG_MAIN'     => lang('Forum'),
				'LANG_NEWTOPIC' => lang('New Topic'),
				// Modified By Kazuya Nouchi POPCOM INC 2002/6/7
				'LANG_REPLYTOPIC' => lang('Post A Message To This Thread'),
//				'LANG_REPLYTOPIC' => lang('Post A Message To This Thread').':',
				'LANG_CATEGORY' => $category['name'],
				'LANG_FORUM'    => $forum['name'],
				'LANG_SEARCH'   => lang('Search'),
				'LANG_POST'     => lang('Post'),
				'FORUM_LINK'    => $GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiforum.forum'),
				'MAIN_LINK'     => $GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiforum.index'),
				'POST_LINK'     => $GLOBALS['phpgw']->link('/index.php',
						Array(
							'menuaction' => 'forum.uiforum.post',
							'type'	=> 'new'
						)
					),
				'THREADS_LINK' => $GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiforum.threads'),
				'SEARCH_LINK'  => $GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiforum.search'),
				'READ_ACTION'  => $GLOBALS['phpgw']->link('/index.php','menuaction=forum.boforum.reply'),
				'MSG'          => $msg,
				'POST'         => $pos,
				'CAT_ID'       => $this->bo->cat_id,
				'FORUM_ID'     => $this->bo->forum_id,
				'ACTION'       => 'reply',
				'LANG_AUTHOR'  => lang('Author'),
				'LANG_DATE'    => lang('Date'),
				'LANG_SUBJECT' => lang('Subject'),
				'LANG_REPLY'   => lang('Email replies to this thread, to the address above'),
				'LANG_SUBMIT'  => lang('Submit'),
				'LANG_MESSAGE' => lang('Message'),
				'LANG_THREADS'	=> lang('Return to forums'),
/*
				'THREADS_LINK' => $GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiforum.threads'),
*/
				// Added By Kazuya Nouchi POPCOM INC 2002/12/17
				'maintenance_tab'	=> $maintenance_tab,
				//---------------------------------------------------------
			);

			$this->template->set_var($var);
			$post_ul = '';
			$pre_ul = '';
			
			$messages = $this->bo->read_msg($this->bo->cat_id,$this->bo->forum_id,$msg);

			while($messages && list($key,$message) = each($messages))
			{
				if($message['id'] == $msg)
				{
					// Added By Kazuya Nouchi POPCOM INC 2002/6/7
					$delete_flag = ($GLOBALS['phpgw_info']['user']['apps']['admin'] || 
						$message['thread_owner'] == $GLOBALS['phpgw_info']['user']['account_id']);
					//-------------------------------------------------------------
					$var = Array(
						// Added By Kazuya Nouchi POPCOM INC 2002/6/7
						'SUBJECT_SELECTED'	=> $message['subject'],
						'AUTHOR_SELECTED'	=> ($message['thread_owner']?$GLOBALS['phpgw']->common->grab_owner_name($message['thread_owner']):lang('Unknown')),	
						'POSTDATE_SELECTED'	=> $GLOBALS['phpgw']->common->show_date($GLOBALS['phpgw']->db->from_timestamp($message['postdate'])),
						'TOPIC_ID_SELECTED'	=> sprintf('%04d',$message['main']),
						'MESSAGE_SELECTED'	=> nl2br($message['message']),
						'DEL_AREA_HEIGHT'	=> ($delete_flag ? '50' : ''),
						'DELETE_ACTION'		=> $GLOBALS['phpgw']->link('/index.php','menuaction=forum.boforum.delete_topic'),
						'DEL_VISIBILITY'	=> ($delete_flag ? 'visible' : 'hidden'),
						//--------------------------------------------
						'THREAD'       	=> $message['thread'],
						'DEPTH'        	=> $message['depth'],
						'MSG'			=> $message['id'],
						'RE_SUBJECT'	=> (!strpos(' '.$message['subject'],'RE: ')?'RE: ':'').$message['subject']
					);
					$this->template->set_var($var);
				}

				$var = Array(
					// Added By Kazuya Nouchi POPCOM INC 2002/6/7
					'TOPIC_ID'			=> sprintf('%04d',$message['main']),
					'icon_image_url'	=> $GLOBALS['phpgw']->common->image('forum',$message['depth'] == 1 ? 'thread' : 'message'),
					'BOLD_START'		=> ($message['id'] == $msg ? '<b>' : ''),
					'BOLD_END'			=> ($message['id'] == $msg ? '</b>' : ''),
					//-----------------------------------------------------
					'AUTHOR'       => ($message['thread_owner']?$GLOBALS['phpgw']->common->grab_owner_name($message['thread_owner']):lang('Unknown')),
					'POSTDATE'     => $GLOBALS['phpgw']->common->show_date($GLOBALS['phpgw']->db->from_timestamp($message['postdate'])),
					'SUBJECT_LINK' => $GLOBALS['phpgw']->link('/index.php',
							Array(
								'menuaction'	=> 'forum.uiforum.read',
								'msg'	=> $message['id'],
								'pos'	=> $message['pos']
							)
						),
					'SUBJECT'      => $message['subject'],
					'MESSAGE'		=> $message['message'],
					'NAME'         => $message['name'],
					'EMAIL'        => $message['email']
				);

				if($key > 0)
				{
					// Modified By Kazuya Nouchi POPCOM INC 2002/6/7
/*
					if ($GLOBALS['phpgw_info']['server']['template_set'] != 'savant')
					{
						for($i=$depth,$pre_ul='',$post_ul='';$i<($message['depth'] - 1);$i++,$pre_ul.='<ul>',$post_ul.='</ul>')
						{
						}
						$this->template->set_var('UL_PRE',$pre_ul);
					}
					else
					{
*/
						$pre_ul = '';
						for($tmp = 1,$move = '';$tmp <= ($message['depth'] - 1); $tmp++)
						{

							$move .= '<td width="20"></td>';
						}
						$var['UL_PRE']=$move;			
//					}
				}
				else
				{
					$depth = $message['depth'] - 1;
				}

				$this->template->set_var($var);

				$this->template->parse('MESSAGE_TEMPLATE','msg_template',True);
				$this->template->set_var('UL_PRE','');
			}
			if($post_ul)
			{
				$this->template->set_var('UL_POST',$post_ul);
			}
			
			$this->template->pfp('Out','read_body');
		}

		function post()
		{
			unset($GLOBALS['phpgw_info']['flags']['noheader']);
			unset($GLOBALS['phpgw_info']['flags']['nonavbar']);
			unset($GLOBALS['phpgw_info']['flags']['noappheader']);
			unset($GLOBALS['phpgw_info']['flags']['noappfooter']);
			$GLOBALS['phpgw']->common->phpgw_header();

			$this->template->set_file(
				Array(
					'POST'	=> 'post.body.tpl'
				)
			);

			$this->template->set_var('row_off',$GLOBALS['phpgw_info']['theme']['row_off']);
			$this->template->set_var('row_on',$GLOBALS['phpgw_info']['theme']['row_on']);

			$category = $this->bo->get_cat_info($this->bo->cat_id);
			$forum = $this->bo->get_forum_info($this->bo->cat_id,$this->bo->forum_id);
			// Added By Kazuya Nouchi POPCOM INC 2002/12/17
			if ($GLOBALS['phpgw_info']['user']['apps']['admin'])
			{
				$maintenance_tab = '<td width="21" align="right" valign="bottom">'.'<img SRC="'.PHPGW_IMAGES.'/tag_btw01.gif" WIDTH="21" HEIGHT="27"></td>'."\n";
				$maintenance_tab .= '<td background="'.PHPGW_IMAGES.'/tag_bg_02.gif" nowrap><a HREF="'.$GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiadmin.index').
					'"><span class="tag" id="tFFFFFF">'.lang('maintenance')."</span></a></td>\n";
				$maintenance_tab .= '<td width="21" align="right" valign="bottom"><img SRC="'.PHPGW_IMAGES.'/tag_r.gif" WIDTH="21" HEIGHT="27"></td>'."\n";
			}
			else
			{
				$maintenance_tab = '<td width="21" align="right" valign="bottom">'.'<img SRC="'.PHPGW_IMAGES.'/tag_r02.gif" WIDTH="21" HEIGHT="27"></td>'."\n";
				$maintenance_tab .= "<td></td>\n<td></td>\n";
			}
			//----------------------------------------------------------------------------------------

			$var = array(
				'BGROUND'       => $GLOBALS['phpgw_info']['theme']['th_bg'],
				'LANG_TOPIC'    => lang('Topic'),
				'LANG_AUTHOR'   => lang('Author'),
				'LANG_REPLIES'  => lang('Replies'),
				'LANG_LATREP'   => lang('Latest Reply'),
				'LANG_MAIN'     => lang('Forum'),
				'LANG_NEWTOPIC' => lang('New Topic'),
				'LANG_REPLYTOPIC' => lang('Post A Message To This Thread').':',
				'LANG_CATEGORY' => $category['name'],
				'LANG_FORUM'    => $forum['name'],
				'LANG_SEARCH'   => lang('Search'),
				'LANG_POST'     => lang('Post'),
				'FORUM_LINK'    => $GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiforum.forum'),
				'MAIN_LINK'     => $GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiforum.index'),
				'POST_LINK'     => $GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiforum.post'),
				'THREADS_LINK'  => $GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiforum.threads'),
				'SEARCH_LINK'   => $GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiforum.search'),
				'POST_ACTION'   => $GLOBALS['phpgw']->link('/index.php','menuaction=forum.boforum.post'),
				'CAT_ID'        => $this->bo->cat_id,
				'FORUM_ID'      => $this->bo->forum_id,
				'TYPE'          => $GLOBALS['HTTP_GET_VARS']['type'],
				'ACTION'        => 'post',
				'LANG_DATE'     => lang('Date'),
				'LANG_SUBJECT'  => lang('Subject'),
				'LANG_REPLY'    => lang('Email replies to this thread, to the address above'),
				'LANG_SUBMIT'   => lang('Submit'),
				'LANG_MESSAGE'  => lang('Message'),
				'LANG_THREADS'  => lang('Return to forums'),
/*
				'THREADS_LINK' => $GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiforum.threads'),
*/
				// Added By Kazuya Nouchi POPCOM INC 2002/6/6
				'image_dir'		=> PHPGW_IMAGES,
				'admin_url'		=> $GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiadmin.index'),
				'submit_readonly'   => (is_array($category) && is_array($forum) ? '' : 'style="visibility:hidden"'),
				// Added By Kazuya Nouchi POPCOM INC 2002/12/17
				'maintenance_tab'	=> $maintenance_tab,
				//---------------------------------------------------------
			);

			$this->template->set_var($var);
			$this->template->pfp('Out','POST');
		}
		// Added By Kazuya Nouchi POPCOM INC 2003/1/29
		function search()
		{
			unset($GLOBALS['phpgw_info']['flags']['noheader']);
			unset($GLOBALS['phpgw_info']['flags']['nonavbar']);
			unset($GLOBALS['phpgw_info']['flags']['noappheader']);
			unset($GLOBALS['phpgw_info']['flags']['noappfooter']);
			$GLOBALS['phpgw']->common->phpgw_header();
			$this->template->set_file(
				Array(
					'search_list_t'	=> 'search.tpl'
				)
			);
			$this->template->set_block('search_list_t','search_list','rows');
			$this->template->set_block('search_list_t','search_error','err');			
			if ($GLOBALS['phpgw_info']['user']['apps']['admin'])
			{
				$maintenance_tab = '<td width="21" align="right" valign="bottom">'.'<img SRC="'.PHPGW_IMAGES.'/tag_btw02.gif" WIDTH="21" HEIGHT="27"></td>'."\n";
				$maintenance_tab .= '<td background="'.PHPGW_IMAGES.'/tag_bg_02.gif" nowrap><a HREF="'.$GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiadmin.index').
					'"><span class="tag" id="tFFFFFF">'.lang('maintenance')."</span></a></td>\n";
				$maintenance_tab .= '<td width="21" align="right" valign="bottom"><img SRC="'.PHPGW_IMAGES.'/tag_r.gif" WIDTH="21" HEIGHT="27"></td>'."\n";
			}
			else
			{
				$maintenance_tab = '<td width="21" align="right" valign="bottom">'.'<img SRC="'.PHPGW_IMAGES.'/tag_r.gif" WIDTH="21" HEIGHT="27"></td>'."\n";
				$maintenance_tab .= "<td></td>\n<td></td>\n";
			}

			if ($GLOBALS['HTTP_POST_VARS']['keywords'])
			{
				$result = $this->bo->search_keywords($GLOBALS['HTTP_POST_VARS']['keywords']);
				if (is_array($result))
				{
					reset($result);
					$ctr = 1;
					while(list($key, $value) = each($result))
					{
						$category = $this->bo->get_cat_info($value['cat_id']);
						$forum = $this->bo->get_forum_info($value['cat_id'],$value['for_id']);
						$this->template->set_var('number', $ctr++);
						$this->template->set_var('category',$category['name']);
						$this->template->set_var('forum',$forum['name']);
						$this->template->set_var('subject',$value['subject']);
						$this->template->set_var('READ_LINK',$GLOBALS['phpgw']->link('/index.php',
							Array( 'menuaction'	=> 'forum.uiforum.read',
								   'cat_id'		=> $value['cat_id'],
								   'forum_id'		=> $value['for_id'],
								   'msg'		=> $value['id'])));
						$this->template->set_var('lang_view',lang('View'));				
						$this->template->fp('rows','search_list',True);	
					}				
				}
				else
				{
					$this->template->set_var('error',lang('no matchs found'));
					$this->template->fp('err','search_error',True);	
				}
			}
			else
			{
				$this->template->set_var('error',lang('you must enter one or more search keywords'));
				$this->template->fp('err','search_error',True);					
			}
			$category = $this->bo->get_cat_info($this->bo->cat_id);
			$forum = $this->bo->get_forum_info($this->bo->cat_id,$this->bo->forum_id);
			$var = array(
				'LANG_MAIN'     => lang('Forum'),
				'MAIN_LINK'     => $GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiforum.index'),
				'POST_LINK'     => $GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiforum.post'),
				'LANG_CATEGORY' => $category['name'],
				'LANG_FORUM'    => $forum['name'],
				'CAT_ID'        => $this->bo->cat_id,
				'FORUM_ID'      => $this->bo->forum_id,
				'image_dir'		=> PHPGW_IMAGES,
				'admin_url'		=> $GLOBALS['phpgw']->link('/index.php','menuaction=forum.uiadmin.index'),
				'maintenance_tab'	=> $maintenance_tab,			
			);
			$this->template->set_var($var);
			$this->template->pfp('Out','search_list_t');	
		}
		//-----------------------------------------------------------------
	}
?>
